'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Option = require('@bootstrap-styled/v4/lib/Option');

var _Option2 = _interopRequireDefault(_Option);

var _Input = require('@bootstrap-styled/v4/lib/Input');

var _Input2 = _interopRequireDefault(_Input);

var _ToggleOption = require('./ToggleOption');

var _ToggleOption2 = _interopRequireDefault(_ToggleOption);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; } /**
                                                                                                                                                                                                                             *
                                                                                                                                                                                                                             * LocaleToggle
                                                                                                                                                                                                                             *
                                                                                                                                                                                                                             */

function Toggle(props) {
  var Tag = props.tag,
      OptionTag = props.optionTag,
      defaultLabel = props.defaultLabel,
      className = props.className,
      onToggle = props.onToggle,
      value = props.value,
      values = props.values,
      messages = props.messages,
      rest = _objectWithoutProperties(props, ['tag', 'optionTag', 'defaultLabel', 'className', 'onToggle', 'value', 'values', 'messages']);
  // If we have items, render them


  var content = !values.length ? _react2.default.createElement(
    _Option2.default,
    null,
    defaultLabel
  ) : values.map(function (v) {
    return _react2.default.createElement(OptionTag, { key: v, value: v, message: messages[v] });
  });
  return _react2.default.createElement(
    Tag,
    _extends({
      type: 'select',
      name: 'select',
      value: value,
      onChange: onToggle,
      className: className
    }, rest),
    content
  );
}

Toggle.defaultProps = {
  tag: _Input2.default,
  optionTag: _ToggleOption2.default,
  defaultLabel: '--',
  messages: {},
  value: '',
  values: [],
  onToggle: function onToggle() {}
};

/* eslint-disable react/require-default-props */
Toggle.propTypes = {
  /**
   * Replace the default component tag by the one specified. Can be:
   */
  tag: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element, _propTypes2.default.object, _propTypes2.default.func]),
  /**
   * Replace the option component tag by the one specified. Can be:
   */
  optionTag: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element, _propTypes2.default.object, _propTypes2.default.func]),
  /**
   * Trigger when toggle
   */
  onToggle: _propTypes2.default.func,
  /**
   * Label used by default when no selection
   */
  defaultLabel: _propTypes2.default.string,
  /**
   * List of all possible values
   */
  values: _propTypes2.default.array,
  /**
   * Current value
   */
  value: _propTypes2.default.string,
  /** @ignore */
  className: _propTypes2.default.string,
  /** react-intl messages (optional) */
  messages: _propTypes2.default.object
};
/* eslint-enable react/require-default-props */

exports.default = Toggle;
module.exports = exports['default'];